
# SerpApi

## What is this

[SerpApi](https://serpapi.com/) is a service that can take a serch word and search in any region in any language in Google and give back the links as results.

SerpApi is a module that currently have two things available for it. The one thing is a service where you can get link for search word from the [SerpApi](https://serpapi.com/) service for any third party module that would want to use it for SEO or research reasons.

The other core feature is that it has one AI Automator type for the AI Automator module that can be found in the [AI module](https://www.drupal.org/project/ai). It makes it possible to take a search word and generate a list of links for the first results for that search word. This together with a scraper module makes it immensly powerful. Like below:

For more information on how to use the AI Automator (previously AI Interpolator), check https://workflows-of-ai.com.

Note that this is the follow up module of the AI Interpolator Serp and makes that module obsolete for Drupal 10.3+.

## Features
* Search using Google search or Google news search.
* Search from any location.
* Search on any regional Google like google.de or google.jp.
* Search for results in any language.
## Requirements
* Requires an account at [SerpApi](https://serpapi.com/). There is a free trial.
* To use it, you need to use a third party module using the service. Currently its only usable with the AI Automator submodule of the [AI module](https://www.drupal.org/project/ai)
## How to use as AI Automator type
1. Install the [AI module](https://www.drupal.org/project/ai).
2. Install this module.
3. Visit /admin/config/serpapi/settings and add your api key from your Tavily account.
4. Create some entity or node type with a string field.
5. Create either a Link field.
6. Enable AI Automator checkbox and configure it.
7. Create an entity of the type you generated, fill in some search word and save.
8. The links will be filled out.
## How to use the SerpApi service.
This is a code example on how you can get links for the search word Why should I use Drupal?".

See https://serpapi.com/search-api for most of the configs available.
```
$serpapi = \Drupal::service('serpapi.api');
// Configure how you want it to run.
$parameters = [
  'engine' => google,
  'q' => 'Why should I use Drupal?'
];
// Get answers in a json array.
$response = $serpapi->searchCall($parameters);
```
